#include "testApp.h"
#include "videoMirror.h"
#include "ofAddons.h"



//--------------------------------------------------------------
void testApp::setup(){	 
	videoImage = new VideoMirror(20,20,640,480);
	grabColor = new unsigned char[3];
}


//--------------------------------------------------------------
void testApp::update(){
	
	ofBackground(100,100,100);
	videoImage->update();
	
}

//--------------------------------------------------------------
void testApp::draw(){
    
    for(int i=0;i<3;i++){
        unsigned char* c = videoImage->getPixel(mousePoint.v, mousePoint.h);
        grabColor[i] = c[i];
    }
    
    ofSetColor(grabColor[0], grabColor[1], grabColor[2]);
    ofRect(0, 0, 680, 520);
    
    ofSetColor(0xffffff);
    videoImage->draw();
    
    makeTarget(mousePoint.v, mousePoint.h);
    //ofEllipse(mousePoint.v, mousePoint.h, 20, 20);
}


void testApp::makeTarget(int _x, int _y){
    // draw a cross hair
    int dia = 30;
    ofHideCursor();
    ofEnableAlphaBlending();
    ofNoFill();
    
    //    ofSetColor(255-grabColor[0], 255-grabColor[1], 255-grabColor[2],100); //invert

    ofSetColor(20, 20, 20, 100);
    // cross hairs, with break in the middle
    for(int i=0;i<4;i+=2){
        ofLine(_x, _y-dia/2+(i*dia/3), _x, _y-dia/2+((i+1)*dia/3));
        ofLine(_x-dia/2+(i*dia/3),_y, _x-dia/2+((i+1)*dia/3),_y);
    }
    ofRect(_x-dia/3, _y-dia/3, 20,20);
    
    _x++;
    _y++;
    
    ofSetColor(200, 200, 200, 100);
    // cross hairs, with break in the middle
    for(int i=0;i<4;i+=2){
        ofLine(_x, _y-dia/2+(i*dia/3), _x, _y-dia/2+((i+1)*dia/3));
        ofLine(_x-dia/2+(i*dia/3),_y, _x-dia/2+((i+1)*dia/3),_y);
    }
    ofRect(_x-dia/3, _y-dia/3, 20,20);
    
    
    // simple crosshairs.
    //ofLine(_x, _y-dia/2, _x, _y+dia/2);
    //ofLine(_x-dia/2, _y, _x+dia/2, _y);
    
    
    
    ofDisableAlphaBlending();
    ofFill();
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	// in fullscreen mode, on a pc at least, the 
	// first time video settings the come up
	// they come up *under* the fullscreen window
	// use alt-tab to navigate to the settings
	// window. we are working on a fix for this...
	
	if (key == 's' || key == 'S'){
		//vidGrabber.videoSettings();
	}
	
	
}


//--------------------------------------------------------------
void testApp::keyReleased(int key){ 
	
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
    mousePoint.v = x;
    mousePoint.h = y;
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
    mousePoint.v = x;
    mousePoint.h = y;
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){

}
