/*
 *  videoMirror.h
 *  openFrameworks
 *
 *  Created by Robert Carlsen on 29.01.2009.
 *  Copyright 2009 recv'd productions. All rights reserved.
 *
 */
#ifndef _VIDEO_MIRROR
#define _VIDEO_MIRROR

#include "ofMain.h"
#include "ofAddons.h"

class VideoMirror : public ofVideoGrabber {
    public:
        VideoMirror();
        VideoMirror(int _x, int _y);
        VideoMirror(int _x, int _y, int _w, int _h);
        ~VideoMirror();
        
        void init(int _x, int _y, int _w, int _h);
        void update();
        void draw();
    
        unsigned char *     getPixel(int _x, int _y);
    
    private:    
        ofVideoGrabber 		vidGrabber;
        unsigned char * 	videoInverted;
        unsigned char *     videoMirrored;
        unsigned char *     selectedPixel;
        ofTexture			videoTexture;
        int 				camWidth;
        int 				camHeight;
        int                 x;
        int                 y;
};


#endif